#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "utils.h"
#include "lv2util.h"

#define PRX_SYSCALL			1022
#define PRX_SYSCALL_OFFSET	0x80000000007F0000ULL
#define PRX_SYSCALL_LOAD	0x1EE7
#define PRX_SYSCALL_UNLOAD	0x364F

//#define LOADER_DEBUG

#ifdef LOADER_DEBUG
#define PAYLOAD_PATH		"/app_home/payload_%X.bin"
#define PRX_PATH			"/app_home/test.sprx"
#define CONF_PATH			"/app_home/plugins.txt"
#else
#define PAYLOAD_PATH		"/dev_hdd0/game/PRXLOADER/USRDIR/payloads/payload_%X.bin"
#define PRX_PATH			"/dev_hdd0/game/PRXLOADER/USRDIR/my.sprx"
#define CONF_PATH			"/dev_hdd0/game/PRXLOADER/USRDIR/plugins.txt"
#endif

uint64_t load_prx_module(uint64_t process_obj, uint32_t slot, char * path, void * arg, uint32_t arg_size)
{
    system_call_6(PRX_SYSCALL, PRX_SYSCALL_LOAD, (uint64_t) process_obj, (uint64_t) slot, (uint64_t) path, (uint64_t) arg, (uint64_t) arg_size);
	return_to_user_prog(uint64_t);
}


uint32_t load_all_prx(char * config_path)
{
	char line[256];
	int len;
	uint32_t slot = 0;

	uint64_t result, vsh_process_obj;

	FILE * f = fopen(config_path,"r");

	if(!f)
		return 0;

	vsh_process_obj = find_vsh_process_obj();
	printf("vsh_process_obj found at: 0x%llx\n", vsh_process_obj);

	while(fgets(line, sizeof line, f) != NULL && slot < 6)
	{
		len = strlen(line);
		if(line[0] != '/' || len == 0)
			continue;

		if(line[len-1] == '\n')
			line[len-1] = 0;
		if(line[len-2] == '\r')
			line[len-2] = 0;

		result = load_prx_module(vsh_process_obj, slot, line, 0, 0);
		printf("load_prx_module %s returned: 0x%llx\n", line, result);
		slot++;
	}

	fclose(f);

	return slot;
}

void patch_errors()
{

}

int main()
{
	uint64_t * payload;
	uint32_t size;
	char payload_path[256];
	int lv2_version = get_lv2_version();

	if(!lv2_version)
	{
		ring_buzzer();
		printf("no suitable payload available\n");
		return -1;
	}

	//patch lv2 protection (rebug only, doesn't affect others)
	if((lv2_version>>4) == 0x446)
	{
		lv1_poke(0x370AA8, 0x0000000000000001ULL);
		lv1_poke(0x370AA8 + 8, 0xE0D251B556C59F05ULL);
		lv1_poke(0x370AA8 + 16, 0xC232FCAD552C80D7ULL);
		lv1_poke(0x370AA8 + 24, 0x65140CD200000000ULL);
	}

	write_htab();
	printf("htab_written\n");
	patch_errors();

	sprintf(payload_path, PAYLOAD_PATH, lv2_version);

	payload = (uint64_t *) read_file(payload_path, &size, 8);
	printf("payload size: %x\n", size);
	install_syscall(PRX_SYSCALL, payload, size, PRX_SYSCALL_OFFSET);
	printf("payload installed\n");
	free(payload);

	//patch permission 4.xx
	lv2_poke(0x8000000000003D90ULL, 0x386000014E800020ULL); // usually "fixed" by warez payload
	printf("permission patch applied\n");

	//dump_lv2("/dev_hdd0/tmp/lv2.bin");

	//result = load_prx_module(vsh_process_obj, 0, PRX_PATH, 0, 0);
	//printf("load_prx_module returned: 0x%llx\n", result);

	load_all_prx(CONF_PATH);
}