#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include "utils.h"

#ifdef PSL1GHT
#define rand_int32_TT800		rand
#endif


void print_hex(uint8_t * buf, uint32_t len)
{
	uint32_t i;
	for(i=0;i<len;i++)
	{
		printf("0x%02x,", buf[i]);
	}

	printf("\n");
}

void get_idps(uint8_t idps[])
{
	system_call_1(870, (uint64_t)idps);
}

void get_psid(uint8_t psid[])
{
	system_call_1(872, (uint64_t)psid);
}

void ring_buzzer()
{
	system_call_3(392, 0x1004, 0xa, 0x1b6);
}

#ifndef PSL1GHT
void sleep(uint64_t time)
{
	system_call_1(142, time);
}
#endif

uint64_t be64(uint8_t * buf)
{
	uint64_t val;
	memcpy(&val, buf, 8);
	return val;
}

uint32_t be32(uint8_t * buf)
{
	uint32_t val;
	memcpy(&val, buf, 4);
	return val;
}

void wbe64(uint8_t * buf, uint64_t val)
{
	memcpy(buf, &val, 8);
}

void wbe32(uint8_t * buf, uint32_t val)
{
	memcpy(buf, &val, 4);
}

void wbe16(uint8_t * buf, uint16_t val)
{
	memcpy(buf, &val, 2);
}

void wbe8(uint8_t * buf, uint8_t val)
{
	buf[0] = val;
}

void get_rand(uint8_t buf[], uint32_t len)
{
	int i;
	uint32_t tmp;

	srand((uint32_t)time(NULL));

	for(i=0;i<len;i+=4)
	{
		tmp=rand_int32_TT800();
		memcpy(buf+i, &tmp, 4);
	}
}

uint8_t * read_file(char *path, uint32_t * file_size, uint16_t round)
{
	uint8_t * buf;
	uint32_t size = 0;
	uint16_t rest;
	FILE * f = fopen(path, "rb");
	if(f)
	{
		uint32_t size = fseek(f, 0, SEEK_END);
		size = ftell(f);
		fseek(f, 0, SEEK_SET);

		if(round)
		{
			rest = size % round;
			if(rest)
				size = size - rest + round;
		}


		buf = malloc(size);
		fread(buf, size, 1, f);
		fclose(f);
		*(file_size) = size;
		return buf;
	}else{
		*(file_size) = 0;
		return NULL;
	}
}

int write_file(uint8_t * buf, char *path, uint32_t size)
{
	FILE * f = fopen(path, "wb");
	int result;
	if(f)
	{
		result = fwrite(buf, size, 1, f);
		fclose(f);
		return result;
	}else{
		return 0;
	}
}